<template>
    <ion-select
        aria-label="Majitel"
        label="Majitel"
        placeholder="Vyberte majitele"
        v-model="model"
    >
        <ion-select-option
            v-for="user in userList"
            :key="user.id"
            :value="user.id"
            >{{ user.name }}({{ user.username }})</ion-select-option
        >
    </ion-select>
</template>

<script setup lang="ts">
import { AppUserEdge } from '@/gql/graphql'
import { useUserStore } from '@/stores/userStore'
import { IonSelect, IonSelectOption } from '@ionic/vue'
import { useLazyQuery } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { computed } from 'vue'

const userStore = useUserStore()

const model = defineModel({ required: true })

const { result: userListResult, load: userListLoad } = useLazyQuery(gql`
    query appUserListSelect {
        appUserList(first: 10000) {
            edges {
                node {
                    id
                    username
                    name
                }
            }
        }
    }
`)

const userList = computed(() => {
    const edgeList = userListResult?.value?.appUserList?.edges
    return edgeList ? edgeList.map((edge: AppUserEdge) => edge.node) : []
})

// Měnit uživatele může jen admin
if (userStore.data.isAdmin) {
    userListLoad()
}
</script>
